
 /*************************˲ΪI2Cߵ*************************************/
//#include<reg52.h>
#include <intrins.h>
#include "I2C.h"
//#include "LCD_Config.h"


//#define  NOP()   _nop_()   /* ָ */
#define  _Nop()  _nop_()   /*ָ*/

 
//sbit     SCL=P2^0;     //I2C  ʱ 
//sbit     SDA=P2^1;     //I2C   

bit ack;                 /*Ӧ־λ*/
   

/*******************************************************************
                     ߺ               
ԭ: void  Start_I2c();  
:     I2C,I2Cʼ.  
********************************************************************/
void Start_I2c()
{
  SDA=1;         /*ʼź*/
  _Nop();
  SCL=1;
  _Nop();        /*ʼʱ4.7us,ʱ*/
  _Nop();
  _Nop();
  _Nop();
  _Nop();    
  SDA=0;         /*ʼź*/
  _Nop();        /* ʼʱ4s*/
  _Nop();
  _Nop();
  _Nop();
  _Nop();       
  SCL=0;       /*ǯסI2Cߣ׼ͻ */
  _Nop();
  _Nop();
}

/*******************************************************************
                      ߺ               
ԭ: void  Stop_I2c();  
:     I2C,I2C.  
********************************************************************/
void Stop_I2c()
{
  SDA=0;      /*ͽź*/
  _Nop();       /*ͽʱź*/
  SCL=1;      /*ʱ4s*/
  _Nop();
  _Nop();
  _Nop();
  _Nop();
  _Nop();
  SDA=1;      /*I2C߽ź*/
  _Nop();
  _Nop();
  _Nop();
  _Nop();
}

/*******************************************************************
                 ֽݷͺ               
ԭ: void  SendByte(UCHAR c);
:     cͳȥ,ǵַ,Ҳ,ȴӦ,
          ״̬λв.(ӦӦʹack=0)     
           ack=1; ack=0ʾӦ𻵡
********************************************************************/
void  SendByte(unsigned char  c)
{
 unsigned char  BitCnt;
 
 for(BitCnt=0;BitCnt<8;BitCnt++)  /*Ҫ͵ݳΪ8λ*/
    {
     if((c<<BitCnt)&0x80)SDA=1;   /*жϷλ*/
       else  SDA=0;                
     _Nop();
     SCL=1;               /*ʱΪߣ֪ͨʼλ*/
      _Nop(); 
      _Nop();             /*֤ʱӸߵƽڴ4s*/
      _Nop();
      _Nop();
      _Nop();         
     SCL=0; 
    }
    
    _Nop();
    _Nop();
    SDA=1;                /*8λͷߣ׼Ӧλ*/
    _Nop();
    _Nop();   
    SCL=1;
    _Nop();
    _Nop();
    _Nop();
    if(SDA==1)ack=0;     
       else ack=1;        /*жǷյӦź*/
    SCL=0;
    _Nop();
    _Nop();
}

/*******************************************************************
                 ֽݽպ               
ԭ: UCHAR  RcvByte();
:        մ,жߴ(Ӧź)
          ӦӦӻ  
********************************************************************/    
unsigned char   RcvByte()
{
  unsigned char  retc;
  unsigned char  BitCnt;
  
  retc=0; 
  SDA=1;                       /*Ϊ뷽ʽ*/
  for(BitCnt=0;BitCnt<8;BitCnt++)
      {
        _Nop();           
        SCL=0;                  /*ʱΪͣ׼λ*/
        _Nop();
        _Nop();                 /*ʱӵ͵ƽڴ4.7s*/
        _Nop();
        _Nop();
        _Nop();
        SCL=1;                  /*ʱΪʹЧ*/
        _Nop();
        _Nop();
        retc=retc<<1;
        if(SDA==1)retc=retc+1;  /*λ,յλretc */
        _Nop();
        _Nop(); 
      }
  SCL=0;    
  _Nop();
  _Nop();
  return(retc);
}

/********************************************************************
                     ӦӺ
ԭ:  void Ack_I2c(bit a);
:      Ӧź(ӦӦźţλa)
********************************************************************/
void Ack_I2c(bit a)
{
  
  if(a==0)SDA=0;              /*ڴ˷ӦӦź */
  else SDA=1;
  _Nop();
  _Nop();
  _Nop();      
  SCL=1;
  _Nop();
  _Nop();                    /*ʱӵ͵ƽڴ4s*/
  _Nop();
  _Nop();
  _Nop();  
  SCL=0;                     /*ʱߣǯסI2CԱ*/
  _Nop();
  _Nop();    
}


/*******************************************************************
ֽ[]ݺ               
*******************************************************************/
bit ISendByte(unsigned char sla,unsigned char *p,unsigned char len)
{
	unsigned char i;
   Start_I2c();              //
   SendByte(sla);            //ַ
   if(ack==0)return(0);
   for(i=0;i< len;i++)
   {
   	 SendByte(*p);              //
	 p++;
   }
   if(ack==0)return(0);
   Stop_I2c();               //
   return(1);
}

/*******************************************************************
ֽݺ               
*******************************************************************/
unsigned char IRcvByte(unsigned char sla)
{  unsigned char c;

   Start_I2c();          //
   SendByte(sla+1);      //ַ
   if(ack==0)return(0);
   c=RcvByte();          //ȡ0

   Ack_I2c(1);           //ͷǾʹλ
   Stop_I2c();           //
   return(c);
}


